/*
 * drei_d.cpp
 *
 *  Created on: 19.05.2010
 *      Author: jack
 */
#include <iostream>
#include <cmath>
#include "drei_d.h"

using namespace std;

//#define _debug

/**
 *  Standard-Konstruktor
 */
drei_d::drei_d () : x(0.0), y(0.0), z(0.0)
{
    #ifdef _debug
    cerr << "___drei_d::drei_d()___" << endl;
    #endif
}

/**
 * Copy-Konstruktor
 */

drei_d::drei_d(const drei_d& orig) : x(orig.x), y(orig.y), z(orig.z)
{
    #ifdef _debug
    cerr << "___drei_d::drei_d(dreid})___" << endl;
    #endif
}

/**
 * Initialisierungskonstruktor
 */
drei_d::drei_d (float i, float j, float k)  : x(i), y(j), z(k)
{
    #ifdef _debug
    cerr << "___drei_d::drei_d(i,j,k)___" << endl;
    #endif
}

// Overload =
drei_d& drei_d::operator = (const drei_d &rhs)
{
    if (this != &rhs)
    {
        x=rhs.x;
        y=rhs.y;
        z=rhs.z;
    }
    return *this;
}

float drei_d::betrag()
{
    return(sqrt(x*x+y*y+z*z));
}

// Overload + (Addition)
drei_d drei_d::operator + (const drei_d& rhs)
{
    return drei_d(x+rhs.x, y+rhs.y, z+rhs.z);
}

// Overload - (Subtraktion)
drei_d drei_d::operator - (const drei_d& rhs)
{

    return drei_d(x-rhs.x, y-rhs.y, z-rhs.z);
}
// Overload * (Kreuzprodukt)
drei_d drei_d::operator * (const drei_d& rhs)
{
    return drei_d(y*rhs.z - z*rhs.y, z*rhs.x - x*rhs.z, x*rhs.y - y*rhs.x);
}

/**
 * Eingabe-Funktion
 */
//bool drei_d::input(drei_d& p)
//{
//    char bl, br, c1, c2;
//    cin >> bl >> p.x >> c1 >> p.y >> c2 >> p.z >> br;
//    if (!(cin.good() && bl == '(' && br == ')' && c1 == ',' && c2 == ','))
//    {
//        cerr << "Eingabefehler" << endl;
//        return false;
//    }
//    else
//        return true;
//}

/**
 * Ausgabe-Funktion
 */
//void drei_d::output()
//{
//    cout << "(" <<  x << ", " << y << ", " << z << ")";
//}

/**
 * Stream-Ausgabe-Operator berladen
 * Ist in Klasse drei_d als friend deklariert
 */
ostream& operator << (ostream& output, const drei_d& p)
{
    output << "(" <<  p.x << ", " << p.y << ", " << p.z << ")";
    return output;  // ermglicht verkettete <<-Operatoren
}

/**
 * Stream-Eingabe-Operator berladen
 * Ist in Klasse drei_d als friend deklariert
 */
istream& operator >> (istream& input, drei_d& p)
{
    char bl, br, c1, c2;
    input >> bl >> p.x >> c1 >> p.y >> c2 >> p.z >> br;
    if (!(cin.good() && bl=='(' && br==')' && c1==',' && c2==','))
    {
        cerr << "Eingabefehler. Vektor bitte so eingeben: (x, y, z)." << endl;
        exit(1);
    }
    return input;
}
